local _timer={};
local _starttime=0;
local _endtime;
local _soundactive = false;
local _enablesfx;
local _mastervol;
local _sfxvol;
local _mastervol_changed = false;
local _sfxvol_changed = false;
local _soundbg;
local _soundenabled;
AddonSoundConfig = {};

function AddonSound_Init()
	AddonSoundConfig:Init();
	_enablesfx = GetCVar("Sound_EnableSFX");
	_mastervol = GetCVar("Sound_MasterVolume");
	_sfxvol = GetCVar("Sound_SFXVolume");
	_soundbg = GetCVar("Sound_EnableSoundWhenGameIsInBG");
	_soundenabled = GetCVar("Sound_EnableAllSound");
	
	
	if (AddonSound_Config.usesecure == nil) then
		--print("notsecure");
		orig_playsound = PlaySound;
		PlaySound = AddonSound_PlaySound;
		orig_playsoundfile = PlaySoundFile;
		PlaySoundFile = AddonSound_PlaySoundFile;
		orig_PlaySoundKitID = PlaySoundKitID;
		PlaySoundKitID = AddonSound_PlaySoundKitID;
	else
		--print("secure");
		hooksecurefunc("PlaySoundKitID",AddonSound_PlaySoundKitID);
		hooksecurefunc("PlaySoundFile", AddonSound_PlaySoundFile);
		hooksecurefunc("PlaySound",AddonSound_PlaySound)
	
	end

end


function AddonSound_TimerEvent(self,elapsed)
	
	if(_soundactive==true) then
		_starttime = _starttime+elapsed;
		if(_starttime > _endtime) then
			AddonSound_DeActivateSound();
		end
	end
end

function AddonSound_ActivateSound()
	if(_soundactive==true) then
		_starttime = 0;
	else
		_starttime = 0;
		_endtime = AddonSound_Config.PlayTime;
		if(_mastervol=="0") then
			SetCVar("Sound_MasterVolume",1.0);
			_mastervol_changed = true;
		end
		if(_sfxvol == "0") then
			SetCVar("Sound_SFXVolume",1.0);
			_sfxvol_changed = true;
		end
		SetCVar("Sound_EnableSFX",1);
		SetCVar("Sound_EnableSoundWhenGameIsInBG",1);
		SetCVar("Sound_EnableAllSound",1);
		_soundactive = true;
	end

end

function AddonSound_DeActivateSound()
	SetCVar("Sound_EnableSFX",_enablesfx);
 	if(_mastervol_changed==true) then
		SetCVar("Sound_MasterVolume",_mastervol);
	end
	if(_sfxvol_changed == true) then
		SetCVar("Sound_SFXVolume",_sfxvol);
	end
	SetCVar("Sound_EnableSoundWhenGameIsInBG",_soundbg);
	SetCVar("Sound_EnableAllSound",_soundenabled);
	_soundactive = false;
end

function AddonSound_PlaySound(...)
	local arg1 = ...;
	if(AddonSound_Ignore[arg1]) then
		if(AddonSound_Ignore[arg1] == 0) then
			AddonSound_ActivateSound();
		end
	else
		AddonSound_ActivateSound();
	end
	if(AddonSound_Config.usesecure==nil) then
		--print("playsound");
		orig_playsound(...);
	end
end



function AddonSound_PlaySoundFile(...)
	AddonSound_ActivateSound();
	if(AddonSound_Config.usesecure==nil) then
	--print("playsoundfile");
		orig_playsoundfile(...);
	end
end

function AddonSound_PlaySoundKitID(...)
	if(soundid == 23292 or soundid == 23291 or soundid == 18019 or soundid == 23287) then
		--return
	else
		AddonSound_ActivateSound();
	end
	if(AddonSound_Config.usesecure==nil) then
		--print("playsoundkitid");
		orig_PlaySoundKitID(...);
	end
end

function AddonSound_OnEvent(self, event, ...)
	local arg1 = ...;
	if(arg1=="AddonSound") then
		AddonSound_Init();
	end
end


AddonSound_timer = CreateFrame("FRAME");
AddonSound_timer:SetScript("OnUpdate", AddonSound_TimerEvent);
AddonSound_timer:SetScript("OnEvent", AddonSound_OnEvent);
AddonSound_timer:RegisterEvent("ADDON_LOADED");

