local config = CreateFrame("Frame");

AddonSoundConfig = config;
function config:SetDefaultConfig()
	AddonSound_Config = {};
	AddonSound_Config.PlayTime = 2.0;
	AddonSound_Config.usesecure = false;
	config.playtime:SetValue(2.0);
end

function config:SetCurrentConfig()
	
	config.playtime:SetValue(AddonSound_Config.PlayTime);
	config.usesecurehook:SetChecked(AddonSound_Config.usesecure);
end

function config:ChangeState(value)
	--AddonSound_Config.PlayTime  = value;
	if(self.id=="playtime") then
		_G[ config.playtime:GetName().."Text" ]:SetText( 'Duration of sound '..config.playtime:GetValue()..' s' );
		AddonSound_Config.PlayTime=config.playtime:GetValue();
	else
		AddonSound_Config.usesecure = self:GetChecked();
	end
end

function config:Init()

	config.name = "Addon Sound Enabler";
	
 
		
	
	local playtime = CreateFrame( "Slider", "PlayTimeSlider", config, "OptionsSliderTemplate" );
	config.playtime = playtime;
	playtime.id = "playtime";
	playtime:SetPoint( "TOPLEFT", 16, -16 );
	playtime:SetWidth(300)
	playtime:SetHeight(20)
	playtime:SetOrientation('HORIZONTAL');
	playtime:SetScript("OnValueChanged",config.ChangeState);
	playtime:SetMinMaxValues(1, 10) ;
	playtime:SetValueStep(0.1);
	_G[ playtime:GetName().."Low" ]:SetText( '1' );
	_G[ playtime:GetName().."High" ]:SetText( '10' );
	_G[ playtime:GetName().."Text" ]:SetText( 'Duration of sound '..playtime:GetValue()..' s' );
 
	local usesecurehook = CreateFrame( "CheckButton", "AddonSound_SecureHookCheckBox", config, "InterfaceOptionsCheckButtonTemplate" );
    config.usesecurehook = usesecurehook;
	usesecurehook.id = "UseSecureHook";
	usesecurehook:SetPoint( "TOPLEFT", playtime, "BOTTOMLEFT", 0, -16);
	usesecurehook:SetScript("onClick",config.ChangeState);
	_G[ usesecurehook:GetName().."Text" ]:SetWidth(350);
	_G[ usesecurehook:GetName().."Text" ]:SetJustifyH("LEFT");
	_G[ usesecurehook:GetName().."Text" ]:SetText( "Use Secure Hook (needs a /reload) |n Use this if you got taint issues, but due the nature how a secure hook works, you wont hear the first bit of a sound and short sounds not at all." );
	
 
 InterfaceOptions_AddCategory(config);
 if not (AddonSound_Config) then
   config:SetDefaultConfig();
 else
   config:SetCurrentConfig();
 end

 

end